package RSSReader::Gtk2UI::Feed::InfoPane;
use strict;
use RSSReader::Feed;
use Gtk2::Pango;
use Data::Dumper;
use base qw(RSSReader::Logger);

our $_feeds_pane;

sub new {
	my $c = shift;
	my %a = @_;

	if (exists $_feeds_pane->{$a{id}}) { return $_feeds_pane->{$a{id}}; }
		
	#otherwise .. fetch the cat and build the widget... after this
	# only redraws are needed.

	my $feed = RSSReader::Feed->new(id=>$a{id});
	my $s = bless { _feed => $feed, id => $a{id} }, $c;

	$_feeds_pane->{$a{id}}=$s;
	#TODO Register em updates da categoria, redraw proposals

	$s->{_widget} = new Gtk2::Table( 3,3,0 );
	$s->{_max_width} = 100;
	$s->{_max_heigth} = 30;
	$s->_redraw();
	

	return $s;
}

sub show {
	my $s = shift;
	$s->widget()->show()
}

sub widget {
	my $s = shift;
	return $s->{_widget};
}

sub id {
	my $s = shift;
	return $s->{id};
}

sub _redraw {
	my $s = shift;

	my $name_label = Gtk2::Label->new( 'Name : ' );
	$name_label->set_markup('<b>Name : </b>');
	my $name = Gtk2::Label->new( $s->{_feed}->label() );
	#$table->attach( $child, $left_attach, $right_attach, $top_attach, $bottom_attach, $xoptions, $yoptions, $xpadding, $ypadding );
	$s->{_widget}->attach( $name_label, 0, 1, 0, 1, ['fill'],'fill'		 , 0 ,5 );
	$s->{_widget}->attach( $name      , 1, 2, 0, 1, ['fill', 'expand'],'fill', 0 ,5 );
	$name->set_alignment(0.0,1.0);
	$name_label->set_alignment(1.0,1.0);

	my $url_label = Gtk2::Label->new();
	$url_label->set_markup('<b>Url : </b>');
	my $url = Gtk2::Label->new( _clean_pass($s->{_feed}->url()) );
        $s->{_widget}->attach( $url_label , 0, 1, 1, 2, ['fill'], 'fill', 0 ,0 );
        $s->{_widget}->attach( $url       , 1, 2, 1, 2, ['fill', 'expand'], 'fill', 0 ,0 );
	$url->set_alignment(0.0,1.0);
	$url_label->set_alignment(1.0,1.0);

        my $draw = Gtk2::Image->new();
        $s->_load_logo($draw);

	$s->{_widget}->attach( $draw, 2,3,0,3,  ['fill'], 'fill', 5 ,5 );

	$s->{_widget}->show_all();
}

sub _load_logo {
	my $s = shift;
	my $draw = shift;

	return unless $s->{_feed}->image();
	$s->log_debug("found an image for this feed");

	my $loader = Gtk2::Gdk::PixbufLoader->new;
	$loader->write($s->{_feed}->image());
	$loader->close();

	my $pb = $loader->get_pixbuf();

	if ( $pb->get_width()>$pb->get_height() && $pb->get_width() > $s->{_max_width}) {

	   my $scale = $pb->get_width()/$s->{_max_width};
           my $det_heigth = $pb->get_height()/$scale;
	   $pb = $pb->scale_simple($s->{_max_width},$det_heigth,'nearest');

	} elsif ( $pb->get_height()>$pb->get_width() && $pb->get_heigth() > $s->{_max_heigth} ) {

	    my $scale = $pb->get_heigth()/$s->{_max_heigth};
	    my $det_width = $pb->get_width()/$scale;
	    $pb = $pb->scale_simple($det_width,$s->{_max_heigth},'nearest');
	}

	$draw->set_from_pixbuf($pb)

}

sub _clean_pass {
  my $url = shift;
  $url =~ s/(http:\/\/)[^\/]*?(@)/$1/;
  return $url;
}
1;
