package RSSReader::Gtk2UI::UrlTester;
use RSSReader::Gtk2UI::Fetcher;
use RSSReader::Gtk2UI::Dialog;

sub run {
    my $c = shift;
    my %a = @_;

    my $window = new Gtk2::Window( "toplevel" );
    $window->set_title( "Testing $a{url}" );
    my $progress = new Gtk2::ProgressBar();     
    $progress->show();
    $window->add( $progress );
    $window->show();
    my ($ret_code, $res) = RSSReader::Gtk2UI::Fetcher->get_rss( $a{url}, syncronous=>1 );

    unless ($ret_code) {
	#failed to get url
    	$window->destroy();
	RSSReader::Gtk2UI::Dialog->run("Could not fetch url");
	return undef
    }
	
    if ($a{dont_parse}) {
    	$window->destroy();
	return 1;
    }

    my $rss =  RSSReader::Fetcher->parse_feed( $res );
    $window->destroy();

    if (!$rss) {
	RSSReader::Gtk2UI::Dialog->run("Url is not a valid RSS Feed");
	return undef;
    }
    RSSReader::Gtk2UI::Dialog->run("Test passed", 'info');

    return $rss;
}

1;
